// Background.H: Background nodes.

// This file has been generated using nodegen 0.5a.
// Restrict manual editing to the sections delimited by
// . the comments "utility includes" and "end of utility includes"
// . the comments "utility members" and "end of utility members"

#ifndef _Background_H_
#define _Background_H_

#include "xrml.H"
#include "Bindable.H"
#include "Children.H"

// utility includes
// end of utility includes

namespace xrml {
#define BackgroundTypeId 	"Background"
extern bool IsBackground(SFNode*);

class Background: public virtual SFNode, public Bindable, public Children {
private:
  //
  void clone_here(const Background&);
  void destruct(void);
  
  // field/eventOut update status bits
  // Use xxx_is_updated() and xxx_clear_update() to inspect/reset.
  enum status_bits {
    groundAngle_updated = 0x1,
    groundColor_updated = 0x2,
    backUrl_updated = 0x4,
    bottomUrl_updated = 0x8,
    frontUrl_updated = 0x10,
    leftUrl_updated = 0x20,
    rightUrl_updated = 0x40,
    topUrl_updated = 0x80,
    skyAngle_updated = 0x100,
    skyColor_updated = 0x200,
    isBound_updated = 0x400 
  };
  
protected:
  // raw eventOut posting:
  void post_isBound(void);

public:
  //
  int major_version(void), minor_version(void);
  bool is_leaf_class(void);
  
  Background();
  Background(const Background&);
  Background& operator=(const Background&);
  virtual ~Background();
  
  //
  SFNode*          	instantiate(Proto * =0);
  void             	render(void);
  
  // state values:
  // Do not assign directly unless you know very well what you are doing.
  MFFloat          	groundAngle;
  MFColor          	groundColor;
  MFString         	backUrl;
  MFString         	bottomUrl;
  MFString         	frontUrl;
  MFString         	leftUrl;
  MFString         	rightUrl;
  MFString         	topUrl;
  MFFloat          	skyAngle;
  MFColor          	skyColor;
  
  // eventIns:
  void             	set_bind(const SFBool&);
  
  // set_<exposedField> eventIns: with forwarding and eventOut generation
  void             	set_groundAngle(const MFFloat&);
  void             	set_groundColor(const MFColor&);
  void             	set_backUrl(const MFString&);
  void             	set_bottomUrl(const MFString&);
  void             	set_frontUrl(const MFString&);
  void             	set_leftUrl(const MFString&);
  void             	set_rightUrl(const MFString&);
  void             	set_topUrl(const MFString&);
  void             	set_skyAngle(const MFFloat&);
  void             	set_skyColor(const MFColor&);
  
  // field assignement: no forwarding or eventOut generation!
  bool             	assign_groundAngle(const MFFloat&);
  bool             	assign_groundColor(const MFColor&);
  bool             	assign_backUrl(const MFString&);
  bool             	assign_bottomUrl(const MFString&);
  bool             	assign_frontUrl(const MFString&);
  bool             	assign_leftUrl(const MFString&);
  bool             	assign_rightUrl(const MFString&);
  bool             	assign_topUrl(const MFString&);
  bool             	assign_skyAngle(const MFFloat&);
  bool             	assign_skyColor(const MFColor&);
  
  // eventOuts:
  //  SFBool            	isBound;
  void             	post_isBound(const SFBool& val);
  
  // update status
  inline bool      	groundAngle_is_updated(void) { return (status & groundAngle_updated); }
  inline void      	groundAngle_clear_update(void) { status &= ~groundAngle_updated; }
  inline bool      	groundColor_is_updated(void) { return (status & groundColor_updated); }
  inline void      	groundColor_clear_update(void) { status &= ~groundColor_updated; }
  inline bool      	backUrl_is_updated(void) { return (status & backUrl_updated); }
  inline void      	backUrl_clear_update(void) { status &= ~backUrl_updated; }
  inline bool      	bottomUrl_is_updated(void) { return (status & bottomUrl_updated); }
  inline void      	bottomUrl_clear_update(void) { status &= ~bottomUrl_updated; }
  inline bool      	frontUrl_is_updated(void) { return (status & frontUrl_updated); }
  inline void      	frontUrl_clear_update(void) { status &= ~frontUrl_updated; }
  inline bool      	leftUrl_is_updated(void) { return (status & leftUrl_updated); }
  inline void      	leftUrl_clear_update(void) { status &= ~leftUrl_updated; }
  inline bool      	rightUrl_is_updated(void) { return (status & rightUrl_updated); }
  inline void      	rightUrl_clear_update(void) { status &= ~rightUrl_updated; }
  inline bool      	topUrl_is_updated(void) { return (status & topUrl_updated); }
  inline void      	topUrl_clear_update(void) { status &= ~topUrl_updated; }
  inline bool      	skyAngle_is_updated(void) { return (status & skyAngle_updated); }
  inline void      	skyAngle_clear_update(void) { status &= ~skyAngle_updated; }
  inline bool      	skyColor_is_updated(void) { return (status & skyColor_updated); }
  inline void      	skyColor_clear_update(void) { status &= ~skyColor_updated; }
  inline bool      	isBound_is_updated(void) { return (status & isBound_updated); }
  inline void      	isBound_clear_update(void) { status &= ~isBound_updated; }
  
  // utility members
  
protected:
  inline void util_init(void) { }
  inline void util_clone(const Background& src) { }
  inline void util_destruct(void) { }
};

// end of utility members
} // namespace xrml
#endif /*_Background_H_*/
