// FontStyle.H: FontStyle nodes.

// This file has been generated using nodegen 0.5a.
// Restrict manual editing to the sections delimited by
// . the comments "utility includes" and "end of utility includes"
// . the comments "utility members" and "end of utility members"

#ifndef _FontStyle_H_
#define _FontStyle_H_

#include "xrml.H"

// utility includes
// end of utility includes

namespace xrml {
#define FontStyleTypeId 	"FontStyle"
extern bool IsFontStyle(SFNode*);

class FontStyle: public virtual SFNode {
private:
  //
  void clone_here(const FontStyle&);
  void destruct(void);
  
  // field/eventOut update status bits
  // Use xxx_is_updated() and xxx_clear_update() to inspect/reset.
  enum status_bits {
    family_updated = 0x1,
    horizontal_updated = 0x2,
    justify_updated = 0x4,
    language_updated = 0x8,
    leftToRight_updated = 0x10,
    size_updated = 0x20,
    spacing_updated = 0x40,
    style_updated = 0x80,
    topToBottom_updated = 0x100 
  };
  
public:
  //
  int major_version(void), minor_version(void);
  bool is_leaf_class(void);
  
  FontStyle();
  FontStyle(const FontStyle&);
  FontStyle& operator=(const FontStyle&);
  virtual ~FontStyle();
  
  //
  SFNode*          	instantiate(Proto * =0);
  void             	render(void);
  
  // state values:
  // Do not assign directly unless you know very well what you are doing.
  MFString         	family;
  SFBool           	horizontal;
  MFString         	justify;
  SFString         	language;
  SFBool           	leftToRight;
  SFFloat          	size;
  SFFloat          	spacing;
  SFString         	style;
  SFBool           	topToBottom;
  
  // field assignement: no forwarding or eventOut generation!
  bool             	assign_family(const MFString&);
  bool             	assign_horizontal(const SFBool&);
  bool             	assign_justify(const MFString&);
  bool             	assign_language(const SFString&);
  bool             	assign_leftToRight(const SFBool&);
  bool             	assign_size(const SFFloat&);
  bool             	assign_spacing(const SFFloat&);
  bool             	assign_style(const SFString&);
  bool             	assign_topToBottom(const SFBool&);
  
  // update status
  inline bool      	family_is_updated(void) { return (status & family_updated); }
  inline void      	family_clear_update(void) { status &= ~family_updated; }
  inline bool      	horizontal_is_updated(void) { return (status & horizontal_updated); }
  inline void      	horizontal_clear_update(void) { status &= ~horizontal_updated; }
  inline bool      	justify_is_updated(void) { return (status & justify_updated); }
  inline void      	justify_clear_update(void) { status &= ~justify_updated; }
  inline bool      	language_is_updated(void) { return (status & language_updated); }
  inline void      	language_clear_update(void) { status &= ~language_updated; }
  inline bool      	leftToRight_is_updated(void) { return (status & leftToRight_updated); }
  inline void      	leftToRight_clear_update(void) { status &= ~leftToRight_updated; }
  inline bool      	size_is_updated(void) { return (status & size_updated); }
  inline void      	size_clear_update(void) { status &= ~size_updated; }
  inline bool      	spacing_is_updated(void) { return (status & spacing_updated); }
  inline void      	spacing_clear_update(void) { status &= ~spacing_updated; }
  inline bool      	style_is_updated(void) { return (status & style_updated); }
  inline void      	style_clear_update(void) { status &= ~style_updated; }
  inline bool      	topToBottom_is_updated(void) { return (status & topToBottom_updated); }
  inline void      	topToBottom_clear_update(void) { status &= ~topToBottom_updated; }
  
  // utility members
  
protected:
  inline void util_init(void) { }
  inline void util_clone(const FontStyle& src) { }
  inline void util_destruct(void) { }
};

// end of utility members
} // namespace xrml
#endif /*_FontStyle_H_*/
