// NavigationInfo.H: NavigationInfo nodes.

// This file has been generated using nodegen 0.5a.
// Restrict manual editing to the sections delimited by
// . the comments "utility includes" and "end of utility includes"
// . the comments "utility members" and "end of utility members"

#ifndef _NavigationInfo_H_
#define _NavigationInfo_H_

#include "xrml.H"
#include "Bindable.H"
#include "Children.H"

// utility includes
// end of utility includes

namespace xrml {
#define NavigationInfoTypeId 	"NavigationInfo"
extern bool IsNavigationInfo(SFNode*);

class NavigationInfo: public virtual SFNode, public Bindable, public Children {
private:
  //
  void clone_here(const NavigationInfo&);
  void destruct(void);
  
  // field/eventOut update status bits
  // Use xxx_is_updated() and xxx_clear_update() to inspect/reset.
  enum status_bits {
    avatarSize_updated = 0x1,
    headlight_updated = 0x2,
    speed_updated = 0x4,
    type_updated = 0x8,
    visibilityLimit_updated = 0x10,
    isBound_updated = 0x20 
  };
  
protected:
  // raw eventOut posting:
  void post_isBound(void);

public:
  //
  int major_version(void), minor_version(void);
  bool is_leaf_class(void);
  
  NavigationInfo();
  NavigationInfo(const NavigationInfo&);
  NavigationInfo& operator=(const NavigationInfo&);
  virtual ~NavigationInfo();
  
  //
  SFNode*          	instantiate(Proto * =0);
  void             	render(void);
  
  // state values:
  // Do not assign directly unless you know very well what you are doing.
  MFFloat          	avatarSize;
  SFBool           	headlight;
  SFFloat          	speed;
  MFString         	type;
  SFFloat          	visibilityLimit;
  
  // eventIns:
  void             	set_bind(const SFBool&);
  
  // set_<exposedField> eventIns: with forwarding and eventOut generation
  void             	set_avatarSize(const MFFloat&);
  void             	set_headlight(const SFBool&);
  void             	set_speed(const SFFloat&);
  void             	set_type(const MFString&);
  void             	set_visibilityLimit(const SFFloat&);
  
  // field assignement: no forwarding or eventOut generation!
  bool             	assign_avatarSize(const MFFloat&);
  bool             	assign_headlight(const SFBool&);
  bool             	assign_speed(const SFFloat&);
  bool             	assign_type(const MFString&);
  bool             	assign_visibilityLimit(const SFFloat&);
  
  // eventOuts:
  //  SFBool            	isBound;
  void             	post_isBound(const SFBool& val);
  
  // update status
  inline bool      	avatarSize_is_updated(void) { return (status & avatarSize_updated); }
  inline void      	avatarSize_clear_update(void) { status &= ~avatarSize_updated; }
  inline bool      	headlight_is_updated(void) { return (status & headlight_updated); }
  inline void      	headlight_clear_update(void) { status &= ~headlight_updated; }
  inline bool      	speed_is_updated(void) { return (status & speed_updated); }
  inline void      	speed_clear_update(void) { status &= ~speed_updated; }
  inline bool      	type_is_updated(void) { return (status & type_updated); }
  inline void      	type_clear_update(void) { status &= ~type_updated; }
  inline bool      	visibilityLimit_is_updated(void) { return (status & visibilityLimit_updated); }
  inline void      	visibilityLimit_clear_update(void) { status &= ~visibilityLimit_updated; }
  inline bool      	isBound_is_updated(void) { return (status & isBound_updated); }
  inline void      	isBound_clear_update(void) { status &= ~isBound_updated; }
  
  // utility members
  
protected:
  inline void util_init(void) { }
  inline void util_clone(const NavigationInfo& src) { }
  inline void util_destruct(void) { }
};

// end of utility members
} // namespace xrml
#endif /*_NavigationInfo_H_*/
