// PhBAshikminReflector.H: PhBAshikminReflector nodes.

// This file has been generated using nodegen 0.51.
// Restrict manual editing to the sections delimited by
// . the comments "utility includes" and "end of utility includes"
// . the comments "utility members" and "end of utility members"

#ifndef _PhBAshikminReflector_H_
#define _PhBAshikminReflector_H_

#include "xrml.H"
#include "PhBScatterer.H"

// utility includes
// end of utility includes

namespace xrml {
#define PhBAshikminReflectorTypeId 	"PhBAshikminReflector"
extern bool IsPhBAshikminReflector(SFNode*);

class PhBAshikminReflector: public virtual SFNode, public PhBScatterer {
private:
  //
  void clone_here(const PhBAshikminReflector&);
  void destruct(void);
  
  // field/eventOut update status bits
  // Use xxx_is_updated() and xxx_clear_update() to inspect/reset.
  enum status_bits {
    nv_updated = 0x1,
    nu_updated = 0x2 
  };
  
public:
  //
  int major_version(void), minor_version(void);
  bool is_leaf_class(void);
  
  PhBAshikminReflector();
  PhBAshikminReflector(const PhBAshikminReflector&);
  PhBAshikminReflector& operator=(const PhBAshikminReflector&);
  virtual ~PhBAshikminReflector();
  
  //
  SFNode*          	instantiate(Proto * =0);
  void             	render(void);
  
  // state values:
  // Do not assign directly unless you know very well what you are doing.
  SFFloat          	nv;
  SFFloat          	nu;
  
  // set_<exposedField> eventIns: with forwarding and eventOut generation
  void             	set_nv(const SFFloat&);
  void             	set_nu(const SFFloat&);
  
  // field assignement: no forwarding or eventOut generation!
  bool             	assign_nv(const SFFloat&);
  bool             	assign_nu(const SFFloat&);
  
  // update status
  inline bool      	nv_is_updated(void) { return (status & nv_updated); }
  inline void      	nv_clear_update(void) { status &= ~nv_updated; }
  inline bool      	nu_is_updated(void) { return (status & nu_updated); }
  inline void      	nu_clear_update(void) { status &= ~nu_updated; }
  
  // utility members
  static float glossy_threshold;

  float albedo(const Vec3& inDir,
	       const complex& IndexIn,
	       const complex& IndexOut,
	       int modes);
  Vec3 sample(const Vec3& inDir,
	      const complex& IndexIn,
	      const complex& IndexOut,
	      float xi1, float xi2,
	      int modes);
  float eval(const Vec3& inDir,
	     const Vec3& outDir,
	     const complex& IndexIn,
	     const complex& IndexOut,
	     int modes, 
	     float *pdf);
  
protected:
  inline void util_init(void) { }
  inline void util_clone(const PhBAshikminReflector& src) { }
  inline void util_destruct(void) { }
};

// end of utility members
} // namespace xrml
#endif /*_PhBAshikminReflector_H_*/
