// PhBHenyeyGreensteinPhaseFunction.H: PhBHenyeyGreensteinPhaseFunction nodes.

// This file has been generated using nodegen 0.51.
// Restrict manual editing to the sections delimited by
// . the comments "utility includes" and "end of utility includes"
// . the comments "utility members" and "end of utility members"

#ifndef _PhBHenyeyGreensteinPhaseFunction_H_
#define _PhBHenyeyGreensteinPhaseFunction_H_

#include "xrml.H"
#include "PhBIsotropicPhaseFunction.H"

// utility includes
// end of utility includes

namespace xrml {
#define PhBHenyeyGreensteinPhaseFunctionTypeId 	"PhBHenyeyGreensteinPhaseFunction"
extern bool IsPhBHenyeyGreensteinPhaseFunction(SFNode*);

class PhBHenyeyGreensteinPhaseFunction: public virtual SFNode, public PhBIsotropicPhaseFunction {
private:
  //
  void clone_here(const PhBHenyeyGreensteinPhaseFunction&);
  void destruct(void);
  
  // field/eventOut update status bits
  // Use xxx_is_updated() and xxx_clear_update() to inspect/reset.
  enum status_bits {
    g_updated = 0x1 
  };
  
public:
  //
  int major_version(void), minor_version(void);
  bool is_leaf_class(void);
  
  PhBHenyeyGreensteinPhaseFunction();
  PhBHenyeyGreensteinPhaseFunction(const PhBHenyeyGreensteinPhaseFunction&);
  PhBHenyeyGreensteinPhaseFunction& operator=(const PhBHenyeyGreensteinPhaseFunction&);
  virtual ~PhBHenyeyGreensteinPhaseFunction();
  
  //
  SFNode*          	instantiate(Proto * =0);
  void             	render(void);
  
  // state values:
  // Do not assign directly unless you know very well what you are doing.
  SFFloat          	g;
  
  // set_<exposedField> eventIns: with forwarding and eventOut generation
  void             	set_g(const SFFloat&);
  
  // field assignement: no forwarding or eventOut generation!
  bool             	assign_g(const SFFloat&);
  
  // update status
  inline bool      	g_is_updated(void) { return (status & g_updated); }
  inline void      	g_clear_update(void) { status &= ~g_updated; }
  
  // utility members
  float albedo(const Vec3& inDir, int modes);
  Vec3 sample(const Vec3& inDir, float xi1, float xi2, int modes);
  float eval(const Vec3& inDir, const Vec3& outDir, int modes, float *pdf);
  
protected:
  inline void util_init(void) { }
  inline void util_clone(const PhBHenyeyGreensteinPhaseFunction& src) { }
  inline void util_destruct(void) { }
};

// end of utility members
} // namespace xrml
#endif /*_PhBHenyeyGreensteinPhaseFunction_H_*/
