// PhBNeumannReflector.H: PhBNeumannReflector nodes.

// This file has been generated using nodegen 0.51.
// Restrict manual editing to the sections delimited by
// . the comments "utility includes" and "end of utility includes"
// . the comments "utility members" and "end of utility members"

#ifndef _PhBNeumannReflector_H_
#define _PhBNeumannReflector_H_

#include "xrml.H"
#include "PhBScatterer.H"

// utility includes
// end of utility includes

namespace xrml {
#define PhBNeumannReflectorTypeId 	"PhBNeumannReflector"
extern bool IsPhBNeumannReflector(SFNode*);

class PhBNeumannReflector: public virtual SFNode, public PhBScatterer {
private:
  //
  void clone_here(const PhBNeumannReflector&);
  void destruct(void);
  
  // field/eventOut update status bits
  // Use xxx_is_updated() and xxx_clear_update() to inspect/reset.
  enum status_bits {
    sharpness_updated = 0x1 
  };
  
public:
  //
  int major_version(void), minor_version(void);
  bool is_leaf_class(void);
  
  PhBNeumannReflector();
  PhBNeumannReflector(const PhBNeumannReflector&);
  PhBNeumannReflector& operator=(const PhBNeumannReflector&);
  virtual ~PhBNeumannReflector();
  
  //
  SFNode*          	instantiate(Proto * =0);
  void             	render(void);
  
  // state values:
  // Do not assign directly unless you know very well what you are doing.
  SFFloat          	sharpness;
  
  // set_<exposedField> eventIns: with forwarding and eventOut generation
  void             	set_sharpness(const SFFloat&);
  
  // field assignement: no forwarding or eventOut generation!
  bool             	assign_sharpness(const SFFloat&);
  
  // update status
  inline bool      	sharpness_is_updated(void) { return (status & sharpness_updated); }
  inline void      	sharpness_clear_update(void) { status &= ~sharpness_updated; }
  
  // utility members
  static float glossy_threshold;

  float albedo(const Vec3& inDir,
	       const complex& IndexIn,
	       const complex& IndexOut,
	       int modes);
  Vec3 sample(const Vec3& inDir,
	      const complex& IndexIn,
	      const complex& IndexOut,
	      float xi1, float xi2,
	      int modes);
  float eval(const Vec3& inDir,
	     const Vec3& outDir,
	     const complex& IndexIn,
	     const complex& IndexOut,
	     int modes, 
	     float *pdf);
  
protected:
  inline void util_init(void) { }
  inline void util_clone(const PhBNeumannReflector& src) { }
  inline void util_destruct(void) { }
};

// end of utility members
} // namespace xrml
#endif /*_PhBNeumannReflector_H_*/
