// StackManager.H: bindable node stack manager

#ifndef _XRML_STACKMANAGER_H_
#define _XRML_STACKMANAGER_H_

#include "Stack.H"

namespace xrml {

class StackManager {
public:
  stack<class Background*> background;
  stack<class Fog*> fog;
  stack<class NavigationInfo*> navigationInfo;
  stack<class Viewpoint*> viewpoint;
#ifdef PhBRML
  stack<class PhBAtmosphere*> phbAtmosphere;
  stack<class PhBBackground*> phbBackground;
  stack<class PhBMonitorCalibration*> phbMonitorCalibration;
#endif

  void init(class world *world);
  void checkin(class Bindable *bindable);
};

} // namespace xrml

#endif /* _XRML_STACKMANAGER_H_ */
